--- misc.c	Sun Nov 17 00:35:03 1996
+++ /usr/src/linux/drivers/char/misc.c	Thu Oct 10 14:58:43 1996
@@ -45,6 +45,9 @@
 
 #include <linux/tty.h> /* needed by selection.h */
 #include "selection.h" /* export its symbols */
+#include "console_struct.h"
+#include "vt_kern.h"   /* the last two for console_get_info */
+
 #ifdef CONFIG_KERNELD
 #include <linux/kerneld.h>
 #endif
@@ -70,6 +73,23 @@
 extern void pcwatchdog_init(void);
 extern int rtc_init(void);
 
+/* console_get_info is used by kmouse */
+
+int console_get_info(int *mode, int *shift, int *col, int *row,
+			struct tty_struct **tty)
+{
+	extern int shift_state;
+	extern struct tty_driver console_driver;
+	struct tty_struct **console_table=console_driver.table;
+
+	if (mode) *mode = vt_cons[fg_console]->vc_mode;
+	if (shift) *shift = shift_state;
+	if (col) *col = video_num_columns;
+	if (row) *row = video_num_lines;
+	if (tty) *tty = console_table[fg_console];
+	return fg_console;
+}
+
 #ifdef CONFIG_PROC_FS
 static int proc_misc_read(char *buf, char **start, off_t offset, int len, int unused)
 {
@@ -180,6 +200,7 @@
 #ifndef MODULE
 	X(set_selection),   /* used by the kmouse module, can only */
 	X(paste_selection), /* be exported if misc.c is in linked in */
+	X(console_get_info), 
 #endif
 #include <linux/symtab_end.h>
 };
